Attribute VB_Name = "Module1"
Option Explicit

Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" _
                          (ByVal dwFlags As Long, lpSource As Any, _
                           ByVal dwMessageId As Long, ByVal dwLanguageId As Long, _
                           ByVal lpBuffer As String, ByVal nSize As Long, _
                           Arguments As Long) As Long

Public Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
Public Const FORMAT_MESSAGE_IGNORE_INSERTS = &H200
Public Const FORMAT_MESSAGE_MAX_WIDTH_MASK = &HFF
Public Const LANG_USER_DEFAULT = &H400&

Function GetAPIErrorStr(errcode As Long) As String
  Dim msgbuf As String, leng As Long

  msgbuf = String(257, 0)
  leng = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM _
                     Or FORMAT_MESSAGE_IGNORE_INSERTS _
                     Or FORMAT_MESSAGE_MAX_WIDTH_MASK, ByVal 0&, _
                     errcode, LANG_USER_DEFAULT, _
                     ByVal msgbuf, 256&, 0&)
  If leng Then
    GetAPIErrorStr = Trim(Left(msgbuf, leng))
  Else
    GetAPIErrorStr = "Neznm chyba."
  End If
End Function
